IF EXISTS ( SELECT * 
            FROM   sysobjects 
            WHERE  id = object_id(N'dbo.CP_Compras_por_Familia') 
                   and OBJECTPROPERTY(id, N'IsProcedure') = 1 )
BEGIN
    DROP PROCEDURE dbo.CP_Compras_por_Familia 
END
GO

CREATE PROCEDURE dbo.CP_Compras_por_Familia
	@pFecha_Desde			DATETIME,
	@pFecha_Hasta			DATETIME,
	@pFamilia               Int,
	@pProveedor             Int,
	@Descrip                CHAR(100)
AS
SET NOCOUNT ON

/*Declaracion Variables Locales*/

DECLARE @Mensaje			VARCHAR(100)
		,@UltError			INT
		,@Id_Trans			INT
		,@Id_Cliente		INT
		,@Importe			DECIMAL(16,2)
		,@Email_Cob			VARCHAR(256)
		,@Id_Trans_Rec		INT
		,@CursorOpen        INT
		,@Flag_Cbte_Tipo	SMALLINT
		,@Periodo           DATE 
		,@Id_sucursal	    SMALLINT
		,@Existe      	    SMALLINT
		,@Venta_Total       DECIMAL(16,2)

					
BEGIN 

IF RTRIM(LTRIM(isnull(@descrip,''))) = '' 
   BEGIN
    set @descrip = '% %'
   END
ELSE
   BEGIN
    set @descrip = '%'+ltrim(rtrim(@Descrip))+'%' 
   END   

 set @Venta_Total =  (Select SUM((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion * isnull(t.Compromete_Compras,0) )
			 	 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and P.id_familia = F.Id_Familia
				   and I.id_Trans = C.Id_Trans
				   AND P.Id_Iva = TI.Id_Iva
				   And c.Id_Estado_Cbte <> 3
				   AND I.CANTIDAD <> 0
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
	         	   And c.Id_Estado_Cbte <> 3
   	               And T.Compromete_COMPRAS in (1,-1)
		           AND C.FECHA >= @pFecha_Desde 
		           AND C.FECHA < dateadd(dd,1,@pFecha_Hasta))
	

IF @pProveedor = 0
   BEGIN
       IF @pFamilia = 0
	      BEGIN
			select P.Id_Familia as Familia,F.Descripcion as Descripcion ,cast(Sum(I.Cantidad*T.Compromete_Compras) as Int) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and P.id_familia = F.Id_Familia
				   and I.id_Trans = C.Id_Trans
				   And c.Id_Estado_Cbte <> 3
				   AND I.CANTIDAD <> 0
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Id_Iva = TI.Id_Iva
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   group by P.Id_Familia,F.Descripcion having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
		ELSE 
		   BEGIN
			select P.Id_Familia as Familia,F.Descripcion as Descripcion ,cast(Sum(I.Cantidad*T.Compromete_Compras) AS INT) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and I.id_Trans = C.Id_Trans
		   	       And P.id_familia = F.Id_Familia
				   And c.Id_Estado_Cbte <> 3
				   AND I.CANTIDAD <> 0
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Id_Iva = TI.Id_Iva
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   AND P.ID_FAMILIA = @pFamilia
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   group by P.Id_Familia,F.Descripcion having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
	    END
	ELSE
       IF @pFamilia = 0
	      BEGIN
			select P.Id_Familia as Familia,F.Descripcion as Descripcion ,CAST(Sum(I.Cantidad*T.Compromete_Compras) AS INT) As Cantidad
				,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) / @Venta_Total) * 100 as Porcentaje
 	            from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and I.id_Trans = C.Id_Trans
				   and P.id_familia = F.Id_Familia
				   And c.Id_Estado_Cbte <> 3
			       AND I.CANTIDAD <> 0
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Id_Iva = TI.Id_Iva
				   AND C.Id_Proveedor = @pProveedor
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   group by P.Id_Familia,F.Descripcion having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
		ELSE 
		   BEGIN
			select P.Id_Familia as Familia,F.Descripcion as Descripcion ,Sum(I.Cantidad*T.Compromete_Compras ) As Cantidad
			    ,SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) as Importe
				, (SUM(((isnull(I.Imp_gravado,0)+isnull(I.Imp_Exento,0))* C.Cotizacion )*isnull(t.Compromete_Compras,0)) / @Venta_Total) * 100 as Porcentaje
				 from cbtes c, cbtes_tipos t, Cbtes_Items I, Productos P, Prod_Familias F, Productos_TasaIva TI
				   where c.id_tipo_cbte  = t.id_tipo_cbte
				   and P.id_familia = F.Id_Familia
				   and I.id_Trans = C.Id_Trans
				   And c.Id_Estado_Cbte <> 3
				   AND P.Id_Producto = I.Id_Producto
				   AND P.Id_Iva = TI.Id_Iva
   				   And T.Compromete_Compras in (1,-1)
				   AND C.FECHA >= @pFecha_Desde 
				   AND I.CANTIDAD <> 0
				   AND C.FECHA < dateadd(dd,1,@pFecha_Hasta)
				   AND C.Id_Proveedor = @pProveedor
				   AND P.ID_FAMILIA = @pFamilia
				   AND P.Descripcion_Detallada like rtrim(ltrim(@descrip))
				   group by P.Id_Familia,F.Descripcion having Sum(I.Cantidad*T.Compromete_Compras) <> 0
				   order by Porcentaje Desc
		   END
   END


 /* 

 SP_compras_por_Familia '20200701','20200831',0,326
 SP_compras_por_Familia '20200701','20200831',0,0,''''

 FIN */

